#include "bits/stdc++.h"
#define puba push_back
#define ff first
#define ss second
#define bend(_x) begin(_x), end(_x)
#define szof(_x) ((int) (_x).size())
#define TASK_NAME "circles"

using namespace std;
typedef long long ll;
typedef pair<int, int> pii;
const int INF = 1e9 + 7;
const double PI = atan2(0, -1);

double dist(double ang1, double ang2) {
    double ret = min(abs(ang1 - ang2), PI * 2 - abs(ang1 - ang2));
    return ret;
}

int main() {
    freopen(TASK_NAME ".in", "r", stdin);
    freopen(TASK_NAME ".out", "w", stdout);

    int n, q;
    scanf("%d%d", &n, &q);

    vector<double> arr;
    for (int i = 0; i < n; ++i) {
        double num;
        scanf("%lf", &num);
        num = num / 180 * PI;
        arr.puba(num);
        arr.puba(num + PI * 2);
        arr.puba(num - PI * 2);
    }

    sort(bend(arr));

    double r1 = 10, r2 = 20;

    for (int i = 0; i < q; ++i) {
        double from, to;
        scanf("%lf%lf", &from, &to);
        from = from / 180 * PI;
        to = to / 180 * PI;
        auto it = lower_bound(bend(arr), to);
        double ans = dist(*it, from) * r1 + (r2 - r1) + dist(*it, to) * r2;
        --it;
        ans = min(ans, dist(*it, from) * r1 + (r2 - r1) + dist(*it, to) * r2);
        printf("%.10f\n", ans);
    }


    #ifdef LOCAL
        cerr << "time: " << clock() << endl;
    #endif
    return 0;
}