#include "testlib.h"
#include <iostream>
#include <vector>

using namespace std;

const int lim = 1e9;
int main(int argc, char* argv[])
{
	registerGen(argc, argv, 1);
	int n = atoi(argv[1]);
	int k = atoi(argv[2]);

	vector <int> a(n);
	a[0] = rnd.wnext(1, 10000, 100);
	int l = rnd.wnext(1, k, 100);
	int sum = 0;
	int i;
	for (i = 1; i < l; i++)
	{
		int delta = rnd.wnext(1, k - sum, -5000);
		sum += delta;
		a[i] = a[0] + delta;
		//cout << a[i] << ' ';
		if (sum >= k)
		{
			break;
		}
	}
	for (; i < n; i++)
	{
		a[i] = rnd.wnext(1, lim, 1000);
	}
	shuffle(a.begin(), a.end());
	cout << n << ' ' << k << "\n";
	for (int i = 0; i < n - 1; i++)
	{
		cout << a[i] << ' ';
	}
	cout << a.back() << "\n";
	return 0;
}
