#include "testlib.h"
#include <iostream>
#include <vector>

using namespace std;

const int lim = 1e9;
int main(int argc, char* argv[])
{
	registerGen(argc, argv, 1);
	int n = atoi(argv[1]);
	int k = rnd.wnext(1, 1000, 10);
	vector <int> a(n);
	a[0] = rnd.wnext(1, 10000, 100);
	for (int i = 1; i < n; i++)
	{
		int delta = rnd.wnext(k + 1, lim - a[0], 1000);
		a[i] = a[0] + delta;
	}
	shuffle(a.begin(), a.end());
	cout << n << ' ' << k << "\n";
	for (int i = 0; i < n - 1; i++)
	{
		cout << a[i] << ' ';
	}
	cout << a[n - 1] << "\n";
	return 0;
}
