#include <bits/stdc++.h>

int solve(std::string &top, std::string &bottom,
          std::string &left, std::string &right) {
  int ans = 0;
  for (int i = 0; i + 1 < static_cast<int>(top.size()); i++) {
    for (int j = i + 1; j < static_cast<int>(top.size()); j++) {
      for (int shift = j - static_cast<int>(bottom.size()) + 1; shift <= i; shift++) {
        char c1 = bottom[i - shift];
        char c2 = bottom[j - shift];
        for (int l = 0; l + 1 < std::min<int>(left.size(), right.size()); l++) {
          for (int k = 0; k + l + 1 < static_cast<int>(left.size()); k++) {
            int kk = k + l + 1;
            for (int k2 = 0; k2 + l + 1 < static_cast<int>(right.size()); k2++) {
              int kk2 = k2 + l + 1;
              if (top[i] == left[k] && c1 == left[kk] && top[j] == right[k2] && c2 == right[kk2]) {
                ans++;
                //std::cerr << top << ' ' << bottom << ' ' << left << ' ' << right << '\n';
                //std::cerr << i << ' ' << j << ' ' << shift << ' ' << l << '\n';
              }
            }
          }
        }
      }
    }
  }
  return ans;
}

int main() {
  freopen("crosswords.in", "r", stdin);
  freopen("crosswords.out", "w", stdout);
  std::vector<std::string> words(4);
  for (int i = 0; i < 4; i++) {
    std::cin >> words[i];
  }
  int ans = 0;
  for (int i = 0; i < 4; i++) {
    for (int j = i + 1; j < 4; j++) {
      std::vector<int> other(2);
      int c = 0;
      for (int k = 0; k < 4; k++) {
        if (k != i && k != j) {
          other[c++] = k;
        }
      }
      int x = other[0];
      int y = other[1];
      ans += solve(words[i], words[j], words[x], words[y]) +
             solve(words[j], words[i], words[x], words[y]) +
             solve(words[i], words[j], words[y], words[x]) +
             solve(words[j], words[i], words[y], words[x]);
    }
  }
  std::cout << ans << '\n';
  return 0;
}
