#include <fstream>
#include <string>

using namespace std;

int count(string &a, string &b, string &c, string &d) 
{
  int res = 0;
  for (int i = 0; i + 1 < a.size(); i++) 
  {
    for (int j = i + 1; j < a.size(); j++) 
	{
		for (int shift = j - b.size() + 1; shift <= i; shift++) 
		{
			char c1 = b[i - shift];
			char c2 = b[j - shift];
			int ans1, ans2;
			for (int l = 0; l + 1 < min(c.size(), d.size()); l++) 
			{
				ans1 = ans2 = 0;
				for (int k = 0; k + l + 1 < c.size(); k++) 
				{
					if (a[i] == c[k] && c1 == c[k + l + 1]) 
					{
						ans1++;
					}
				}
				for (int k = 0; k + l + 1 < d.size(); k++) 
				{
					if (a[j] == d[k] && c2 == d[k + l + 1]) 
					{
						ans2++;
					}
				}
				res += ans1 * ans2;
			}
		}
    }
  }
  return res;
}

int main() 
{
	ifstream cin("crosswords.in");
	ofstream cout("crosswords.out");
	string s[4];

	for (int i = 0; i < 4; i++) 
	{
		cin >> s[i];
	}

	int ans = 0;
	for (int i = 0; i < 4; i++) 
	{
		for (int j = i + 1; j < 4; j++) 
		{
			pair <int, int> one = make_pair(i, j);
			pair <int, int> rest =	make_pair(-1, -1);
			for (int k = 0; k < 4; k++) 
			{
				if (k != i && k != j) 
				{
					rest.first == -1 ? rest.first = k : rest.second = k;
				}
			}
			int change1[4] = {0, 0, 1, 0};
			int change2[4] = {0, 1, 0, 1};
			for (int k = 0; k < 4; k++)
			{
				if (change1[k])
				{
					swap(one.first, one.second);
				}
				if (change2[k])
				{
					swap(rest.first, rest.second);
				}
				ans += count(s[one.first], s[one.second], s[rest.first], s[rest.second]);
			}
		}
	}
	cout << ans;
	return 0;
}
