#include <bits/stdc++.h>

int main() {
  freopen("pluses.in", "r", stdin);
  freopen("pluses.out", "w", stdout);
  int n, m;
  char s[5010];
  scanf("%d%d", &n, &m);
  std::vector<std::vector<int>> matrix(n, std::vector<int>(m, 0));
  for (int i = 0; i < n; i++) {
    scanf("%s", s);
    for (int j = 0; j < m; j++) {
      matrix[i][j] = s[j] - '0';
    }
  }
  std::vector<std::vector<int>> left(n, std::vector<int>(m, 0));
  std::vector<std::vector<int>> up(n, std::vector<int>(m, 0));
  for (int i = 0; i < n; i++) {
    for (int j = 0; j < m; j++) {
      if (matrix[i][j] == 0) {
        left[i][j] = 0;
        up[i][j] = 0;
        continue;
      }
      left[i][j] = 1 + (j > 0 ? left[i][j - 1] : 0);
      up[i][j] = 1 + (i > 0 ? up[i - 1][j] : 0);
    }
  }
  std::vector<std::vector<int>> right(n, std::vector<int>(m, 0));
  std::vector<std::vector<int>> down(n, std::vector<int>(m, 0));
  for (int i = n - 1; i >= 0; i--) {
    for (int j = m - 1; j >= 0; j--) {
      if (matrix[i][j] == 0) {
        right[i][j] = 0;
        down[i][j] = 0;
        continue;
      }
      right[i][j] = 1 + (j < m - 1 ? right[i][j + 1] : 0);
      down[i][j] = 1 + (i < n - 1 ? down[i + 1][j] : 0);
    }
  }
  int maxAns = INT_MIN;
  int ri = -1;
  int rj = -1;
  for (int i = 0; i < n; i++) {
    for (int j = 0; j < m; j++) {
      if (matrix[i][j] == 1) {
        int x = std::min(left[i][j], std::min(right[i][j], std::min(up[i][j], down[i][j])));
        if (maxAns < x * 4 - 3) {
          maxAns = x * 4 - 3;
          ri = i;
          rj = j;
        }
      }
    }
  }
  if (ri == -1) {
    printf("-1\n");
  } else {
    printf("%d\n%d %d\n", maxAns, ri + 1, rj + 1);
  }
  return 0;
}
