import random
random.seed("basic04/amulet")

class TestGen:
    def __init__(self):
        self.test_number = 0

    def generate_samples(self):
        self.print_test(4, 3)

    def generate_min_tests(self):
        for x in range(1, 6):
            for y in range(1, 6):
                self.print_test(x, y)

    def generate_hand_tests(self):
        pass

    def generate_random_test(self, maxn):
        self.print_test(random.randint(5, maxn), random.randint(5, maxn))

    def generate_max_tests(self, maxn):
        self.print_test(1, 10**9)
        self.print_test(10**9, 1)
        self.print_test(10**9, 10**9)

    def print_test(self, x, y):
        self.test_number += 1
        print('Generating test #%d' % self.test_number)

        test_name = "{0:0=2d}".format(self.test_number)
        test_file = open(test_name, "w")
        print(x, y, file=test_file)
        test_file.close()

    def generate_all_tests(self):
        self.generate_samples()
        self.generate_min_tests()
        self.generate_hand_tests()
        
        ns = [10, 50, 100, 500, 10**3, 10**4, 10**5, 10**6, 10**7, 10**8, 10**9]
        for n in ns:
            self.generate_random_test(n)
        self.generate_max_tests(30)

import time
start = time.time()
writer = TestGen()
writer.generate_all_tests()
finish = time.time()
print('All tests were generated. Elapsed time: ', finish - start)
