#include "bits/stdc++.h"
#define puba push_back
#define ff first
#define ss second
#define bend(_x) begin(_x), end(_x)
#define szof(_x) ((int) (_x).size())
#define TASK_NAME "array"

using namespace std;
typedef long long ll;
typedef pair<int, int> pii;
const int INF = 1e9 + 7;
const double PI = atan2(0, -1);

int n, m;
vector<pii> segs;

void split(int l, int r) {
    //cerr << "split" << endl;
    //cerr << l << " " << r << endl;
    int nowl = 0, nowr = 0;
    for (int i = 0; i < szof(segs); ++i) {
        auto& s = segs[i];
        nowr = nowl + s.ss - s.ff;
        //cerr << nowl << " " << nowr << endl;
        if (r <= nowl || nowr <= l || (l <= nowl && nowr <= r)) {
            nowl = nowr;
            continue;
        }
        if (l > nowl) {
            int shift = s.ff - nowl;
            s.ss = l + shift;
            if (r < nowr) {
                segs.insert(segs.begin() + i + 1, {l + shift, r + shift});
                segs.insert(segs.begin() + i + 2, {r + shift, nowr + shift});
                break;
            } else {
                segs.insert(segs.begin() + i + 1, {l + shift, nowr + shift});
                i += 1;
            }
        } else {
            int shift = s.ff - nowl;
            s.ss = r + shift;
            segs.insert(segs.begin() + i + 1, {r + shift, nowr + shift});
            i += 1;
        }
        nowl = nowr;
    }
}

void my_swap(int l1, int r1, int l2, int r2) {
    //cerr << "swap" << endl;
    //cerr << l1 << " " << r1 << " " << l2 << " " << r2 << endl;
    int now = 0;
    int pl1 = -1, pr1 = -1, pl2 = -1, pr2 = -1;

    for (int j = 0; j < szof(segs); ++j) {
        if (now == l1) {
            pl1 = j;
        }
        if (now == r1) {
            pr1 = j;
        }
        if (now == l2) {
            pl2 = j;
        }
        if (now == r2) {
            pr2 = j;
        }
        now += segs[j].ss - segs[j].ff;
    }

    if (now == l1) {
        pl1 = szof(segs);
    }
    if (now == r1) {
        pr1 = szof(segs);
    }
    if (now == l2) {
        pl2 = szof(segs);
    }
    if (now == r2) {
        pr2 = szof(segs);
    }

    //cerr << pl1 << " " << pr1 << " " << pl2 << " " << pr2 << endl;

    vector<pii> s1, s2;
    for (int j = pl1; j < pr1; ++j) {
        s1.puba(segs[j]);
    }
    for (int j = pl2; j < pr2; ++j) {
        s2.puba(segs[j]);
    }
    vector<pii> between, after;
    for (int j = pr1; j < pl2; ++j) {
        between.puba(segs[j]);
    }
    for (int j = pr2; j < szof(segs); ++j) {
        after.puba(segs[j]);
    }
    segs.resize(pl1);
    for (pii j : s2) {
        segs.puba(j);
    }
    for (pii j : between) {
        segs.puba(j);
    }
    for (pii j : s1) {
        segs.puba(j);
    }
    for (pii j : after) {
        segs.puba(j);
    }
}

vector<int> inp;

int get(int l, int r, int a, int b) {
    return upper_bound(inp.begin() + l, inp.begin() + r, b) - lower_bound(inp.begin() + l, inp.begin() + r, a);
}

int main() {
    freopen(TASK_NAME ".in", "r", stdin);
    freopen(TASK_NAME ".out", "w", stdout);

    scanf("%d%d", &n, &m);
    
    for (int i = 0; i < n; ++i) {
        int num;
        scanf("%d", &num);
        inp.puba(num);
    }

    vector<vector<int>> reqs;
    segs = {{0, n}};
    for (int i = 0; i < m; ++i) {
        //cerr << "i: " << i << endl;
        /*
        for (pii p : segs) {
            cerr << p.ff << " - " << p.ss << "    ";
        }
        cerr << endl;*/
        int type;
        scanf("%d", &type);
        if (type == 1) {
            int l1, r1, l2, r2;
            scanf("%d%d%d%d", &l1, &r1, &l2, &r2);
            --l1; --l2;
            
            if (l1 > l2) {
                swap(l1, l2);
                swap(r1, r2);
            }

            reqs.puba({type, l1, r1, l2, r2});
            
            split(l1, r1);
            split(l2, r2);
            /*
            cerr << "after split" << endl;
            for (pii p : segs) {
                cerr << p.ff << " - " << p.ss << "    ";
            }
            cerr << endl;
            */
            my_swap(l1, r1, l2, r2);
        } else {
            int l, r, a, b;
            scanf("%d%d%d%d", &l, &r, &a, &b);
            --l;
            split(l, r);
            reqs.puba({type, l, r, a, b});
        }
    }

    sort(bend(segs));
    for (auto s : segs) {
        //cerr << s.ff << " " << s.ss << endl;
        sort(inp.begin() + s.ff, inp.begin() + s.ss);
    }

    for (int i = 0; i < m; ++i) {
        /*
        for (pii p : segs) {
            cerr << p.ff << " - " << p.ss << "    ";
        }
        cerr << endl;*/
        if (reqs[i][0] == 1) {
            int l1 = reqs[i][1], r1 = reqs[i][2], l2 = reqs[i][3], r2 = reqs[i][4];
            
            my_swap(l1, r1, l2, r2);
        } else {
            int l = reqs[i][1], r = reqs[i][2], a = reqs[i][3], b = reqs[i][4];
            
            int ans = 0;
            int now = 0;
            int pl = -1, pr = -1;
            for (int j = 0; j < szof(segs); ++j) {
                if (now == l) {
                    pl = j;
                }
                if (now == r) {
                    pr = j;
                }
                now += segs[j].ss - segs[j].ff;
            }
            if (now == l) {
                pl = szof(segs);
            }
            if (now == r) {
                pr = szof(segs);
            }

            for (int j = pl; j < pr; ++j) {
                ans += get(segs[j].ff, segs[j].ss, a, b);
            }
            cout << ans << "\n";
        }
    }

    #ifdef LOCAL
        cerr << "time: " << clock() << endl;
    #endif
    return 0;
}