#include <bits/stdc++.h>

const double pi = acos(-1.0);

double d(double angle, double r) {
  return angle * pi / 180 * r;
}

double distance(double a, double b, double r) {
  double alpha2 = std::abs(a - b);
  while (alpha2 < 0) {
    alpha2 += 360.0;
  }
  while (alpha2 >= 360.0) {
    alpha2 -= 360.0;
  }
  double alpha = 360.0 - alpha2;
  while (alpha < 0) {
    alpha += 360.0;
  }
  while (alpha >= 360.0) {
    alpha -= 360.0;
  }
  return d(std::min(alpha, alpha2), r);
}

int main() {
  freopen("circles.in", "r", stdin);
  freopen("circles.out", "w", stdout);
  int n, q;
  scanf("%d%d", &n, &q);
  std::vector<double> angles(n);
  for (int i = 0; i < n; i++) {
    scanf("%lf", &angles[i]);
    angles.push_back(angles[i] + 360.0);
    angles.push_back(angles[i] - 360.0);
  }
  std::sort(angles.begin(), angles.end());
  for (int i = 0; i < q; i++) {
    double a, b;
    scanf("%lf%lf", &a, &b);
    int index = std::lower_bound(angles.begin(), angles.end(), b) - angles.begin();
    double minAns = distance(a, angles[index - 1], 10.0) + distance(angles[index - 1], b, 20.0) + 10.0;
    minAns = std::min(minAns, distance(a, angles[index], 10.0) + distance(angles[index], b, 20.0) + 10.0);
    printf("%.20f\n", minAns);
  }
  return 0;
}
