#include <bits/stdc++.h>

using namespace std;

const int MAXN = 1 << 18;

int n;
vector<int> e[MAXN * 2];
int vis[MAXN * 2];
int ans;
vector<int> vct;

void dfs(int v) {
	vis[v] = 1;
	vct.push_back(v);
	int ff = lower_bound(vct.begin(), vct.end(), v + n - 1, greater<int>()) - vct.begin();
	ans = max(ans, (int)vct.size() - ff);
	for (int to : e[v]) {
		dfs(to);
	}
	vct.pop_back();
}

int solve(vector<int> a) {
	n = a.size();
	for (int i = 0; i < n * 2; i++) {
		e[i].clear();
		vis[i] = 0;
	}
	vector<int> vct;
	for (int i = 0; i < n * 2; i++) {
		while (!vct.empty() && a[i % n] > a[vct.back() % n]) {
			e[i].push_back(vct.back());
			vct.pop_back();
		}
		vct.push_back(i);
	}
	ans = 0;
	for (int i = 2 * n - 1; i >= 0; i--) {
		if (vis[i]) continue;
		dfs(i);
	}
	return ans;
}

int main() {
	freopen("deepcycle.in", "r", stdin);
	freopen("deepcycle.out", "w", stdout);
	
	int n;
	scanf("%d", &n);
	vector<int> a(n);
	for (int i = 0; i < n; i++) scanf("%d", &a[i]);
	printf("%d\n", solve(a));

	return 0;
}