#include <bits/stdc++.h>

using namespace std;

const int MAXN = 1 << 18;
const double TL = 2.0;

int slowsolve(vector<int> a) {
	int n = a.size();
	int ans = 0;
	for (int it = 0; it < n; it++) {
		if (clock() / (double)CLOCKS_PER_SEC > 0.9 * TL) break;
		vector<int> mx(n);
		vector<int> vct;
		for (int i = 0; i < n; i++) {
			mx[i] = 1;
			while (!vct.empty() && a[vct.back()] < a[i]) {
				mx[i] = max(mx[i], mx[vct.back()] + 1);
				vct.pop_back();
			}
			vct.push_back(i);
		}
		for (int i = 0; i < n; i++) ans = max(ans, mx[i]);
		rotate(a.begin(), a.begin() + 1, a.end());
	}
	return ans;
}

int main() {
	freopen("deepcycle.in", "r", stdin);
	freopen("deepcycle.out", "w", stdout);

	//stress();

	int n;
	scanf("%d", &n);
	vector<int> a(n);
	for (int i = 0; i < n; i++) scanf("%d", &a[i]);
	printf("%d\n", slowsolve(a));

	return 0;
}