#include <stdio.h>
#include <iostream>
#include <algorithm>
#include <string>
using namespace std;

const int MAX = 5005;
bool a[MAX][MAX];
short up_[MAX][MAX];
short down_[MAX][MAX];
short left_[MAX][MAX];
short right_[MAX][MAX];

int main()
{
	freopen("pluses.in", "r", stdin);
	freopen("pluses.out", "w", stdout);
	ios_base::sync_with_stdio(false);
	int n, m;
	cin >> n >> m;

	for (int i = 0; i < n; i++)
	{
		string s;
		cin >> s;
		for (int j = 0; j < m; j++)
			a[i][j] = s[j] - '0';
	}

	/* up */
	for (int j = 0; j < m; j++)
		for (int i = 1; i < n; i++)
            if (a[i - 1][j])
				up_[i][j] = up_[i - 1][j] + 1;

	/* down */
	for (int j = 0; j < m; j++)
		for (int i = n - 2; i >= 0; i--)
			if (a[i + 1][j])
				down_[i][j] = down_[i + 1][j] + 1;
			
	/* left */
	for (int i = 0; i < n; i++)
		for (int j = 1; j < m; j++)
			if (a[i][j - 1])
				left_[i][j] = left_[i][j - 1] + 1;
			
	/* right */
	for (int i = 0; i < n; i++)
		for (int j = m - 2; j >= 0; j--)
			if (a[i][j + 1])
				right_[i][j] = right_[i][j + 1] + 1;
			
	int ans = -1, x = 0, y = 0;
	int res;
	for (int i = 0; i < n; i++)
		for (int j = 0; j < m; j++)
		{
			res = min(up_[i][j], min(down_[i][j], min(left_[i][j], right_[i][j])));
			if (a[i][j] && res > ans)
			{
				ans = res;
				x = i + 1;
				y = j + 1;
			}
		}

	if (ans == -1)
		cout << "-1" << endl;
	else
		cout << ans * 4 + 1 << endl << x << " " << y << endl;

	return 0;
}